<template>
  <div class="qcreate">
    <div class="qcreate-title">
      Омода намудан/сохтани супориш барои <b> такмили ихтисос </b>
    </div>

    <form @submit.prevent="create()" class="qcreate-form">
      <!-- <div class="qcreate-item">
        <span> Если задание от внешнего сервиса, то вставьте ссылку </span>
        <Input v-model="form.link" />
      </div> -->

      <div class="qcreate-item">
        <span> Чӣ гуна супориш ? </span>
        <div>
          <Select
            :data="type_exercises_list"
            v-model="form.type_exercise"
            single
            required
          />
        </div>
      </div>

      <div class="qcreate-item">
        <span> Барои кадом ихтисос? </span>
        <div>
          <Select
            :data="specializations_list"
            v-model="form.specializations"
            multiple
            required
            @input="specializationChangeCategoryAndEvent()"
          />
        </div>
      </div>

      <div class="qcreate-item" v-if="form.specializations">
        <span> Кадом категория ? </span>
        <div>
          <Select
            :data="categories_list.map((el) => `${el.name}`)"
            v-model="form.categories"
            single
            required
            @input="categoryChangeCategoryAndEvent()"
          />
        </div>
      </div>

      <div class="qcreate-item" v-if="form.categories">
        <span> Навъи чорабини </span>
        <div>
          <Select
            :data="event_ckeck(events_list)"
            v-model="form.event"
            single
            required
          />
        </div>
      </div>

      <div class="qcreate-article-items">
        <div>
          <span> Сарлавҳа </span>
          <Input v-model="form.title" required />
        </div>
        <div class="qcreate-article-items__upload">
          <span> Тасвир </span>
          <input
            type="file"
            accept=".png,image/png,.jpg,image/jpg,.jpeg,image/jpeg"
            @change="inputImage"
            ref="imageInput"
            class="upload-input"
            required
          />
          <button
            type="button"
            class="form-btn"
            @click="$refs.imageInput.click()"
          >
            Илова намудани сурат
          </button>
        </div>
      </div>

      <span>Кори шумо чӣ гуна мешавад:</span>
      <div class="qcreate-article" ref="article">
        <div class="qcreate-article__img">
          <img :src="exercise_blob" />
          <div class="qcreate-article__img-wrapper">
            <div class="qcreate-article__img-spcialization">
              <span v-for="spc in form.specializations"> — {{ spc }} </span>
            </div>
          </div>
        </div>
        <div class="qcreate-article__content">
          <div class="qcreate-article__content-title">
            {{ form.title }}
          </div>
          <div class="qcreate-article__content-slots">
            — {{ form.categories }}
          </div>
          <div class="qcreate-article__content-slots">
            — {{ form.event.replace(" - " + form.type_exercise, "") }}
          </div>
        </div>
      </div>

      <div class="qcreate-item" v-if="form.link == ''">
        <span>Тавсиф</span>
        <span v-if="warning_description" style="color: #ff5c5c">
          * лутфан тавсифро пур кунед
        </span>
        <client-only>
          <VueEditor v-model="form.desc" :editor-toolbar="custom_toolbar" />
        </client-only>
      </div>

      <div class="qcreate-materials">
        <span>Маводҳои оид ба супориш</span>
        <input
          type="file"
          accept=".pdf,.word,.doc,.docx"
          @change="inputMaterials"
          ref="fileInput"
          class="upload-input"
        />
        <button type="button" class="form-btn" @click="$refs.fileInput.click()">
          Илова кардани мавод
        </button>
        <div
          class="qcreate-materials__name"
          v-for="(material, index) in materials_blob"
          :key="material.name"
        >
          <a :href="material.url" target="_blank">
            <b> {{ index + 1 }}.</b> {{ material.name }}
          </a>
          <button type="button" @click="removeMaterial(material)">
            Тоза кунед
          </button>
        </div>
      </div>

      <div class="qcreate-test">
        <span>Барои супориш тест илова кунед</span>
        <button
          v-if="!is_test"
          type="button"
          class="form-btn"
          @click="is_test = true"
        >
          Илова кардани тест
        </button>
        <button
          v-else
          type="button"
          class="form-btn"
          @click="
            form.test = [];
            is_test = false;
            test_warning = false;
          "
        >
          Тоза кардани тест
        </button>
        <div
          v-if="is_test"
          :class="[
            'qcreate-test__wrapper',
            test_warning ? 'qcreate-test__wrapper--warning' : '',
          ]"
          ref="test"
        >
          <div>
            <button
              type="button"
              class="form-btn qcreate-test__addques"
              @click="addQuestions()"
            >
              Илова намудани савол
            </button>
          </div>
          <div>
            <div
              v-for="(test, t_index) in form.test"
              :key="t_index"
              class="qcreate-test__content"
            >
              <div :ref="'question_' + t_index" class="qcreate-test__question">
                <div>
                  <span> Савол {{ t_index + 1 }} </span>
                  <Input
                    v-model="test.question"
                    placeholder="Саволро нависед"
                  />
                </div>
                <button
                  type="button"
                  class="form-btn"
                  @click="removeQuestions(t_index)"
                  style="float: right"
                >
                  {{ t_index + 1 }} саволро нест намоед
                </button>
              </div>
              <div class="qcreate-test__answers-wrapper">
                <span>
                  * Ҷавоби аввал ҷавоби дуруст ба савол хоҳад буд (аммо барои
                  шунаванда, ҷавобҳо ҳарҷо ҳарҷо хоҳанд буд)
                </span>
                <div
                  v-for="(answer, a_index) in test.answers"
                  :key="a_index"
                  class="qcreate-test__answers"
                >
                  <div>
                    <span>
                      Ҷавоби {{ a_index + 1 }}
                      {{ a_index == 0 ? " - ҷавоби дуруст" : "" }}
                    </span>
                    <Input
                      v-model="answer.text"
                      placeholder="Ҷавобро нависед"
                    ></Input>
                  </div>
                  <button
                    type="button"
                    class="form-btn"
                    @click="removeAnswer(t_index, a_index)"
                  >
                    {{ a_index + 1 }} ҷавобро нест кунед
                  </button>
                </div>
                <button
                  type="button"
                  class="form-btn qcreate-test__answers-add"
                  @click="addAnswers(t_index)"
                >
                  Варианти ҷавобро илова кунед
                </button>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="qcreate-item">
        <span> Шумораи соатҳои кредитӣ </span>
        <Input v-model="form.credit" type="number" required />
      </div>

      <div class="qcreate-item">
        <span> Шакли ҳисоботро барои гирифтани соатҳои кредитӣ нависед</span>
        <div>
          <Input v-model="form.reports" required />
        </div>
      </div>

      <button type="submit" class="curve-btn qcreate-item">
        <div>Сохтан/омода намудан</div>
      </button>
    </form>
  </div>
</template>

<script>
const TYPE_EXERCISES = ["Чорабиниҳо", "Такмили ихтисос", "Маводҳо"];
export default {
  layout: "profile",
  middleware: "auth",

  data() {
    return {
      form: {
        url: "",
        link: "",
        type_exercise: "",
        specializations: [],
        categories: "",
        event: "",
        title: "",
        image: "",
        desc: "",
        materials: [],
        test: [],
        credit: "",
        reports: "",
        teacher_id: this.$auth.user._id,
        teacher_name: this.$auth.user.name,
        teacher_phone: this.$auth.user.phone,
        teacher_workplace: this.$auth.user.workplace,
        teacher_avatar: this.$auth.user.avatar,
        access: false,
      },

      is_test: false,
      test_warning: false,

      exercise_image: null,
      exercise_blob: null,

      materials_blob: [],

      specializations_list_store: [],
      categories_list_store: [],
      events_list_store: [],
      specializations_list: [],
      categories_list: [],
      events_list: [],

      type_exercises_list: TYPE_EXERCISES,

      custom_toolbar: [
        [
          {
            header: [false, 1, 2, 3, 4, 5, 6],
          },
        ],
        ["bold", "italic", "underline", "strike"], // toggled buttons
        [
          {
            align: "",
          },
          {
            align: "center",
          },
          {
            align: "right",
          },
          {
            align: "justify",
          },
        ],
        ["blockquote", "code-block"],
        [
          {
            list: "ordered",
          },
          {
            list: "bullet",
          },
          {
            list: "check",
          },
        ],
        [
          {
            indent: "-1",
          },
          {
            indent: "+1",
          },
        ],
        [
          {
            color: [],
          },
          {
            background: [],
          },
        ],
        ["link"],
        ["clean"],
      ],

      warning_description: false,
    };
  },

  computed: {
    event_ckeck() {
      return (value) => {
        return value
          .filter((el) => el.type === this.form.type_exercise)
          .map((el) => `${el.name}\n - ${el.type}\n`);
      };
    },
  },

  fetchOnServer: false,
  fetch() {
    this.getSettings();
  },

  methods: {
    create() {
      if (this.form.link == "" && this.form.desc == "") {
        this.warning_description = true;
        this.$refs.article.scrollIntoView({
          behavior: "smooth",
        });
      } else {
        this.warning_description = false;
        // if (!this.validateTest()) {
          this.uploadImage()
            .then(() => {
              this.uploadMaterials()
                .then(() => {
                  this.$axios
                    .$post("/exercise/addExercise", this.form)
                    .then(() => {
                      this.$router.push("/profile/exercises");
                    })
                    .catch((error) => {
                      console.log(error);
                    });
                })
                .catch((err) => {
                  //Надо сделать так что если произошла ошибка, то удалить фотку
                  console.log(err);
                });
            })
            .catch((err) => console.log(err));
        // }
      }
    },

    validateTest() {
      if (this.is_test) {
        if (this.form.test.length > 0) {
          this.form.test.forEach((test) => {
            if (test.question == "") {
              this.test_warning = true;
              return;
            } else {
              this.test_warning = false;
            }
            if (test.answers.length > 0) {
              test.answers.forEach((answer) => {
                if (answer.text == "") {
                  this.test_warning = true;
                  return;
                } else {
                  this.test_warning = false;
                }
              });
            } else {
              this.test_warning = true;
            }
          });
        } else {
          this.test_warning = true;
        }
        if (this.test_warning) {
          this.$nextTick(() => {
            this.$refs.test.scrollIntoView({
              behavior: "smooth",
              block: "start",
              inline: "start",
            });
          });
        } else {
          this.test_warning = false;
        }
      } else {
        alert("Барои супориш тест илова кунед");
        this.test_warning = true;
      }

      if (this.form.test.length < 10) {
        alert("Тест бояд на камтар аз 10 савол дошта бошад");
        this.test_warning = true;
      }

      return this.test_warning;
    },

    removeQuestions(i) {
      this.form.test = this.form.test.filter((el, index) => index !== i);
    },

    addQuestions() {
      this.form.test.push({
        question: "",
        answers: [],
      });
      this.$nextTick(() => {
        let question = "question_" + (this.form.test.length - 1);
        this.$refs[question][0].scrollIntoView({ behavior: "smooth" });
      });
    },

    addAnswers(i) {
      this.form.test.forEach((test, index) => {
        if (index == i) {
          test.answers.push({
            text: "",
          });
          test.answers[0].correct = true;
        }
      });
    },

    removeAnswer(test_index, answer_index) {
      this.form.test.forEach((test, t_index) => {
        if (test_index === t_index) {
          test.answers = test.answers.filter(
            (el, a_index) => a_index !== answer_index
          );
          if (test.answers.length > 0) {
            test.answers[0].correct = true;
          }
        }
      });
    },

    async uploadImage() {
      const imageName =
        this.form.title +
        "." +
        this.exercise_image.type.split("/").pop().trim();
      const formData = new FormData();
      formData.append("exercise", this.exercise_image, imageName);
      const url = this.$config.UPLOADS_BACKEND_URL + "/uploadExercise";
      try {
        let response = await this.$axios.$post(url, formData, {
          headers: {
            "content-type": "multipart/form-data",
          },
        });
        if (response.answer === "ok") {
          this.form.image = "/exercises/images/" + imageName;
        }
      } catch (err) {
        throw new Error("uploadImage error", err);
      }
    },
    async inputImage(e) {
      const exercise = e.target.files[0];
      if (exercise === undefined) {
        return;
      }
      if (exercise.size > 524288) {
        alert("Андозаи акс набояд аз 500 килобайт зиёд бошад ");
      } else {
        const reader = new FileReader();
        reader.readAsDataURL(exercise);
        reader.onload = (onloadEvent) => {
          this.exercise_blob = onloadEvent.target.result;
          this.exercise_image = exercise;
        };
      }
    },

    async uploadMaterials() {
      const formData = new FormData();
      this.materials_blob.forEach((el) => {
        formData.append("exerciseMaterials", el.file, el.name);
      });
      const url = this.$config.UPLOADS_BACKEND_URL + "/uploadExerciseMaterials";
      try {
        await this.$axios.$post(url, formData, {
          headers: {
            "content-type": "multipart/form-data",
          },
        });
      } catch (err) {
        throw new Error("uploadMaterials error", err.response);
      }
    },
    async inputMaterials(e) {
      const material = e.target.files[0];
      if (material === undefined) {
        return;
      }
      if (material.size > 524288 * 6) {
        alert("Андозаи ҳуҷҷат набояд аз 3 мегабайт зиёд бошад");
      } else {
        const blob = new Blob(e.target.files, {
          type: material.type,
        });
        const url = window.URL.createObjectURL(blob);
        this.form.materials.push("/exercises/materials/" + material.name);
        this.materials_blob.push({
          name: material.name,
          url: url,
          file: material,
        });
      }
    },
    removeMaterial(material) {
      this.$refs.fileInput.value = "";
      this.materials_blob = this.materials_blob.filter(
        (el) => el.name !== material.name
      );
      this.form.materials = this.form.materials.filter(
        (el) => el !== material.name
      );
    },

    async getSettings() {
      this.$axios
        .$get("/settings")
        .then((response) => {
          this.specializations_list = this.specializations_list_store =
            response.specializations_list[0].data.filter(
              (el) => el.label !== "Омӯзгор"
            );
          this.categories_list = this.categories_list_store =
            response.categories_list;
          this.events_list = this.events_list_store = response.events_list;
        })
        .catch((error) => {
          console.log(error);
        });
    },

    specializationChangeCategoryAndEvent() {
      this.form.categories = "";
      this.categories_list = this.categories_list_store;
      this.categories_list = this.categories_list.filter((el) =>
        this.form.specializations.some((r) => el.specializations.includes(r))
      );
    },

    categoryChangeCategoryAndEvent() {
      this.form.event = "";
      this.events_list = this.events_list_store;
      this.events_list = this.events_list.filter((el) => {
        console.log(el.categories.includes(this.form.categories));
        return el.categories.includes(this.form.categories);
      });
    },
  },
};
</script>

<style lang="scss" scoped>
.qcreate {
  margin-left: 20px;
  padding: 20px;
  background-color: #fff;
  box-shadow: 1px 1.732px 10px 0 rgb(0 0 0 / 5%);
  min-height: 70vh;
  width: 100%;
  @include less-than(tablet) {
    margin-left: 0px;
  }

  &-title {
    line-height: 1.3;
    font-size: 36px;

    @include less-than(tablet) {
      font-size: 22px;
    }
  }

  &-form {
    span {
      display: block;
      margin-bottom: 10px;
    }
  }

  &-item {
    margin-top: 20px;
  }

  &-article-items {
    margin: 20px 0;
    display: grid;
    grid-template-columns: repeat(3, 1fr);
    text-align: left;
    grid-gap: 40px;
    position: relative;
    @include less-than(tablet) {
      grid-template-columns: repeat(1, 1fr);
      grid-gap: 20px;
    }
  }

  &-article-items__upload {
    position: relative;
    input {
      width: 80%;
      height: 20px;
      position: absolute;
    }
  }

  &-article {
    background-color: #fff;
    box-shadow: 1px 1.732px 10px 0 rgb(0 0 0 / 5%);
    overflow: hidden;
    height: fit-content;
    transition: all ease 0.3s;
    margin-top: 20px;
    width: 30%;
    @include less-than(laptop) {
      width: 100%;
    }
    &:hover {
      .qualifications-article__img {
        img {
          transform: scale(1.1);
        }
      }
    }
  }
  &-article__img {
    height: 205px;
    overflow: hidden;
    transition: all ease 0.3s;
    position: relative;
    img {
      width: 100%;
      height: 100%;
      object-fit: cover;
      transition: all ease 0.3s;
    }
  }
  &-article__img-wrapper {
    position: absolute;
    bottom: 20px;
    right: 15px;
    display: flex;
  }
  &-article__img-spcialization {
    padding: 10px;
    background-color: #0c63e4;
    color: #fff;
    font-size: 14px;
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    span {
      display: inherit;
      margin-bottom: 0px;
    }
  }
  // &-article__img-comments {
  //   padding: 10px;
  //   background-color: #fff;
  //   color: #000;
  //   border-radius: 10px;
  //   font-size: 14px;
  //   display: flex;
  //   align-items: center;
  //   transition: all ease 0.3s;
  //   &:hover {
  //     transform: scale(1.1);
  //   }
  // }
  &-article__content {
    padding: 20px;
  }
  &-article__content-title {
    color: #0c63e4;
    font-weight: 500;
    font-size: 18px;
    letter-spacing: 0.02em;
    margin-bottom: 10px;
  }
  &-article__content-slots {
    font-size: 14px;
    letter-spacing: 0.04em;
    text-underline-offset: 0.2em;
  }

  &-materials {
    margin: 20px 0;
  }
  &-materials__name {
    margin-top: 20px;
    margin-left: 20px;
    a:hover {
      color: #0c63e4;
    }
    button {
      margin-left: 20px;
      font-weight: 800;
      background: none;
      &:hover {
        color: #0c63e4;
      }
    }
  }

  &-test {
    margin: 20px 0;
  }
  &-test__wrapper {
    margin: 20px 0;
    display: grid;
    grid-template-columns: auto 1fr;
    text-align: left;
    grid-gap: 40px;
    position: relative;
    border: 1px solid #e1e1e6;
    border-radius: 12px;
    padding: 20px;
    transition: all ease 0.3s;
    @include less-than(laptop) {
      grid-template-columns: 1fr;
      grid-gap: 20px;
      padding: 10px;
    }

    button {
      height: fit-content;
    }
  }
  &-test__wrapper--warning {
    border-color: #ff5c5c;
  }
  &-test__addques {
    position: sticky;
    top: 80px;
    @include less-than(laptop) {
      top: 0px;
      position: relative;
    }
  }
  &-test__content {
    margin-bottom: 20px;
    border: 1px solid #e1e1e6;
    border-radius: 12px;
    padding: 20px;
    @include less-than(laptop) {
      padding: 10px;
    }
  }
  &-test__question {
    display: grid;
    grid-template-columns: 2.5fr 1fr;
    text-align: left;
    align-items: flex-end;
    grid-gap: 40px;
    @include less-than(laptop) {
      grid-template-columns: 1fr;
      grid-gap: 20px;
      padding: 10px;
    }
  }
  &-test__answers-wrapper {
    border: 1px solid #e1e1e6;
    border-radius: 12px;
    padding: 20px;
    margin-top: 20px;
    @include less-than(laptop) {
      padding: 10px;
    }
  }
  &-test__answers {
    display: grid;
    grid-template-columns: 2.5fr 1fr;
    text-align: left;
    align-items: flex-end;
    grid-gap: 40px;
    margin-bottom: 20px;
    @include less-than(laptop) {
      grid-template-columns: 1fr;
      grid-gap: 20px;
      padding: 10px;
    }
  }
}
</style>
